## libaria 2.8.0+repack

=== Makefile ===
####
#### Aria top level makefile
####
####
#### Internal variables:
####
#### CFILEEXT -- This is to denote the file extension that is used. This is
####             used by the build rules to figure out which files to build.
####               ie: cpp
####               ie: cxx
####               ie: cc

# Make sure we're using a compiler (we probably don't need to define
# it but we have been so here it is unless it was already set)
ifndef CXX
CXX:=g++
endif

####
#### General variables
####

CFILEEXT:=cpp
# this is set up with the extra layer since the python wrapper needs exceptions
# but I didn't want to have two sets of defines
BARECXXFLAGS:=-g -Wall -D_REENTRANT  #-pg -fprofile-arcs
CXXFLAGS+=$(BARECXXFLAGS) -fno-exceptions 
CXXINC:=-Iinclude
CXXLINK=-Llib -lAria
CXXSTATICLINK:=-Llib -Xlinker -Bstatic -lAria -Xlinker -Bdynamic 

host:=$(shell uname | cut -d _ -f 1)
ifeq ($(host),MINGW32)
  $(info Building on MinGW)
	#CXXFLAGS+=-mwindows -mms-bitfields -D__MINGW__ -DMINGW
	CXXFLAGS+=-mms-bitfields -D__MINGW__ -DMINGW
	CXXLINK+=-lpthreadGC2 -lwinmm -lws2_32 -lstdc++
	CXXSTATICLINK+=-Wl,-Bstatic -lpthread -Wl,-Bdynamic -lwinmm -lws2_32 -lstdc++
	binsuffix:=.exe
else
	BARECXXFLAGS+=-fPIC
	CXXLINK+=-lpthread -ldl -lrt
	CXXSTATICLINK+=-Xlinker -Bdynamic -lpthread -ldl -lrt -Xlinker -Bstatic -lstdc++ -Xlinker -Bdynamic
	binsuffix:=
endif


ifndef JAVAC
ifdef JAVA_BIN
JAVAC:=$(JAVA_BIN)/javac
else
JAVAC:=javac
endif #ifdef JAVA_BIN
endif #ifndef JAVAC

ifndef JAR
ifdef JAVA_BIN
JAR:=$(JAVA_BIN)/jar
else
JAR:=jar
endif #ifdef JAVA_BIN
endif #ifndef JAR

####
#### Aria build variables
####

# Default targets to build in the default rule:
TARGETS:=lib/libAria.so examples/demo$(binsuffix)

# Default static libraries and examples:
STATIC_TARGETS:=lib/libAria.a examples/demoStatic$(binsuffix)

# Lots of targets, to build in the everything rule:
ALL_TARGETS:=lib/libAria.so utils examples tests docs params lib/libArNetworking.so swig arnetworking_docs arnetworking_swig clib/libArNetworking.a $(STATIC_TARGETS)

CFILES:= \
	ArAction.cpp \
	ArActionAvoidFront.cpp \
	ArActionAvoidSide.cpp \
	ArActionBumpers.cpp \
	ArActionColorFollow.cpp \
	ArActionConstantVelocity.cpp \
	ArActionDeceleratingLimiter.cpp \
	ArActionDesired.cpp \
	ArActionDriveDistance.cpp \
	ArActionGoto.cpp \
	ArActionGotoStraight.cpp \
	ArActionGroup.cpp \
	ArActionGroups.cpp \
	ArActionInput.cpp \
	ArActionIRs.cpp \
	ArActionJoydrive.cpp \
	ArActionKeydrive.cpp \
	ArActionLimiterBackwards.cpp \
	ArActionLimiterForwards.cpp \
	ArActionLimiterRot.cpp \
	ArActionLimiterTableSensor.cpp \
	ArActionMovementParameters.cpp \
	ArActionMovementParametersDebugging.cpp \
	ArActionRatioInput.cpp \
	ArActionRobotJoydrive.cpp \
	ArActionStallRecover.cpp \
	ArActionStop.cpp \
	ArActionTriangleDriveTo.cpp \
	ArActionTurn.cpp \
	ArACTS.cpp \
	ArAMPTU.cpp \
	ArAnalogGyro.cpp \
	ArArg.cpp \
	ArArgumentBuilder.cpp \
	ArArgumentParser.cpp \
	ArASyncTask.cpp \
	ArBasePacket.cpp \
	ArBatteryConnector.cpp \
	ArBatteryMTX.cpp \
	ArBumpers.cpp \
	ArCameraCommands.cpp \
	ArCameraCollection.cpp \
	ArCondition_LIN.cpp \
	ArConfig.cpp \
	ArConfigArg.cpp \
	ArConfigGroup.cpp \
	ArDataLogger.cpp \
	ArDeviceConnection.cpp \
	ArDPPTU.cpp \
	ArFileParser.cpp \
	ArForbiddenRangeDevice.cpp \
	ArFunctorASyncTask.cpp \
	ArGPS.cpp \
	ArGPSConnector.cpp \
	ArGPSCoords.cpp \
	ArGripper.cpp \
	ArInterpolation.cpp \
	ArIrrfDevice.cpp \
	ArIRs.cpp \
	ArJoyHandler.cpp \
	ArKeyHandler.cpp \
	ArLaser.cpp \
	ArLaserConnector.cpp \
	ArLaserFilter.cpp \
	ArLaserLogger.cpp \
	ArLaserReflectorDevice.cpp \
	ArLCDConnector.cpp \
	ArLCDMTX.cpp \
	ArLineFinder.cpp \
	ArLMS1XX.cpp \
	ArLMS2xx.cpp \
	ArLMS2xxPacket.cpp \
	ArLMS2xxPacketReceiver.cpp \
	ArLog.cpp \
	ArLogFileConnection.cpp \
	ArMap.cpp \
	ArMapComponents.cpp \
	ArMapInterface.cpp \
	ArMapObject.cpp \
	ArMapUtils.cpp \
	ArMD5Calculator.cpp \
	ArMode.cpp \
	ArModes.cpp \
	ArModule.cpp \
	ArModuleLoader.cpp \
	ArMutex.cpp \
	ArMutex_LIN.cpp \
	ArNetServer.cpp \
	ArNMEAParser.cpp \
	ArNovatelGPS.cpp \
	ArP2Arm.cpp \
	ArPriorityResolver.cpp \
	ArPTZ.cpp \
  ArPTZConnector.cpp \
	ArRangeBuffer.cpp \
	ArRangeDevice.cpp \
	ArRangeDeviceThreaded.cpp \
	ArRatioInputKeydrive.cpp \
	ArRatioInputJoydrive.cpp \
	ArRatioInputRobotJoydrive.cpp \
	ArRecurrentTask.cpp \
	ArRobot.cpp \
	ArRobotBatteryPacketReader.cpp \
	ArRobotConfig.cpp \
	ArRobotConfigPacketReader.cpp \
	ArRobotConnector.cpp \
	ArRobotJoyHandler.cpp \
	ArRobotPacket.cpp \
	ArRobotPacketReceiver.cpp \
	ArRobotPacketReaderThread.cpp \
	ArRobotPacketSender.cpp \
	ArRobotParams.cpp \
	ArRobotTypes.cpp \
	ArRVisionPTZ.cpp \
	ArS3Series.cpp \
	ArSZSeries.cpp \
	ArSick.cpp \
	ArSimpleConnector.cpp \
	ArSimulatedLaser.cpp \
	ArSocket.cpp \
	ArSonarConnector.cpp \
	ArSonarDevice.cpp \
	ArSonarMTX.cpp \
	ArSensorReading.cpp \
	ArSonyPTZ.cpp \
	ArSoundsQueue.cpp \
	ArSoundPlayer.cpp \
	ArStringInfoGroup.cpp \
	ArSyncLoop.cpp \
	ArSyncTask.cpp \
	ArSystemStatus.cpp \
	ArSonarAutoDisabler.cpp \
	ArSpeech.cpp \
	ArTCM2.cpp \
	ArTCMCompassDirect.cpp \
	ArTCMCompassRobot.cpp \
	ArTcpConnection.cpp \
	ArThread.cpp \
	ArThread_LIN.cpp \
	ArTransform.cpp \
	ArTrimbleGPS.cpp \
	ArUrg.cpp \
	ArUrg_2_0.cpp \
	ArVCC4.cpp \
	Aria.cpp \
	ariaUtil.cpp \
	md5.cpp

# Omit some Linux-only classes, and replace others with Win32 implementations.
ifeq ($(host),MINGW32)
	CFILES+=ArSocket_WIN.cpp \
		ArJoyHandler_WIN.cpp \
		ArSerialConnection_WIN.cpp \
		ArSignalHandler_WIN.cpp
else
	CFILES+=ArSocket_LIN.cpp \
		ArJoyHandler_LIN.cpp \
		ArSerialConnection_LIN.cpp \
		ArSignalHandler_LIN.cpp \
		ArVersalogicIO.cpp \
    ArMTXIO.cpp
endif




####
#### Utility variables. No need to touch these.
####

OTFILES:=$(patsubst %.$(CFILEEXT),%.o,$(CFILES))
OFILES:=$(patsubst %,obj/%,$(OTFILES))
EXAMPLES_CPP:=$(shell find examples -name "*.$(CFILEEXT)" | grep -v Mod.cpp | grep -v proprietary)
EXAMPLES:=$(patsubst %.$(CFILEEXT),%$(binsuffix),$(EXAMPLES_CPP))
EXAMPLES_STATIC:=$(patsubst %,%Static$(binsuffix),$(EXAMPLES))
MOD_EXAMPLES_CPP:=$(shell find examples -name "*.$(CFILEEXT)" | grep Mod.cpp)
MOD_EXAMPLES:=$(patsubst %.$(CFILEEXT),%.so,$(MOD_EXAMPLES_CPP))
TESTS_CPP:=$(shell find tests -name "*.$(CFILEEXT)" | grep -v Mod.cpp | grep -v proprietary)
MOD_TESTS_CPP:=$(shell find tests -name "*Mod.$(CFILEEXT)")
MOD_TESTS:=$(patsubst %.$(CFILEEXT),%.so,$(MOD_TESTS_CPP))
TESTS:=$(patsubst %.$(CFILEEXT),%$(binsuffix),$(TESTS_CPP))
TESTS_STATIC:=$(patsubst %,%Static$(binsuffix),$(TESTS))
ADVANCED_CPP:=$(shell find advanced -name "*.$(CFILEEXT)" | grep -v Mod.cpp | grep -v proprietary)
ADVANCED:=$(patsubst %.$(CFILEEXT),%,$(ADVANCED_CPP))
UTILS_CPP:=$(shell find utils -name "*.$(CFILEEXT)")
UTILS:=$(patsubst %.$(CFILEEXT),%$(binsuffix),$(UTILS_CPP))
SRC_FILES:=$(patsubst %,src/%,$(CFILES))
HEADER_FILES:=$(shell find include -type f -name \*.h)




####
#### General rules for user invocation
####

# Default Rule
all: dirs $(TARGETS)

# Build all targets, docs, params, etc. etc.
everything: dirs $(ALL_TARGETS) 

static: dirs $(STATIC_TARGETS)

# Build everything required for distribution packages
dist-all: lib/libAria.so params docs CommandLineOptions.txt.in \
  lib/libArNetworking.so ArNetworking/CommandLineOptions.txt.in examples/demo \
  examples/demoStatic ArNetworking/examples/serverDemo \
  ArNetworking/examples/serverDemoStatic ArNetworking/examples/clientDemo \
  ArNetworking/examples/clientDemoStatic java python  arnetworking_swig \
  arnetworking_docs

examples: $(EXAMPLES) 

modExamples: $(MOD_EXAMPLES)

tests: $(TESTS) $(MOD_TESTS)

advanced: $(ADVANCED)

utils: $(UTILS)

cleanDep:
	-rm Makefile.dep `find . -name Makefile.dep`

# directories that might not exist:
dirs:
	@mkdir -p -v obj
	@mkdir -p -v lib

docs: doc
doc: docs/index.html
docs/index.html: $(SRC_FILES) $(HEADER_FILES) $(EXAMPLES_CPP) docs/overview.dox docs/options/all_options.dox docs/params.dox
	@echo Removing old documentation...
	$(MAKE) cleanDoc
	@echo Running dist/make-doc.sh to generate HTML API documentation...
	dist/make-doc.sh dev ARIA_DIST_NO_NTP=1
	
arnetworking_swig:
	$(MAKE) -C ArNetworking java python

arnetworking_docs:
	$(MAKE) -C ArNetworking docs

help:
	@echo To make most things, run \'make\' or \'make all\'
	@echo Some useful targets include: 
	@echo "  allLibs, cleanAllLibs, depAllLibs (do all subdirectories)"
	@echo "  clean"
	@echo "  dep"
	@echo "  cleanDep"
	@echo "  docs"
	@echo "  cleanAll (also cleans ArNetworking, java, python, etc.)"
	@echo "  examples"
	@echo "  tests"
	@echo "  utils"
	@echo "  python" 
	@echo "  cleanPython"
	@echo "  java" 
	@echo "  cleanJava"
	@echo "  examples/<Some Example>, where examples/<Some Example>.cpp is an example program source file."
	@echo "  tests/<Some Test>, where tests/<Some Test>.cpp is a test program source file."
	@echo "  allLibs (try to build all auxilliary libraries that you have installed by running make in each directory starting with \"Ar\")"
	@echo "  cleanAllLibs, depAllLibs (do make clean or make dep in the \"Ar*\" auxilliary libraries)"
	@echo "  install (if this is a source tar.gz package)"

info:
	@echo ARIA=$(ARIA)
	@echo CXX=$(CXX)
	@echo CXXFLAGS=$(CXXFLAGS)
	@echo CXXINC=$(CXXINC)
	@echo CXXLINK=$(CXXLINK)
	@echo CXXSTATICLINK=$(CXXSTATICLINK)
	@echo ALL_TARGETS=$(ALL_TARGETS)
	@echo
	@echo JAVAC=$(JAVAC)
	@echo JAR=$(JAR)
	@echo
	@echo Use \'make moreinfo\' for info about individual files, etc.

moreinfo:
	@echo CFILES=$(CFILES)
	@echo
	@echo EXAMPLES=$(EXAMPLES)
	@echo
	@echo MOD_EXAMPLES=$(MOD_EXAMPLES)
	@echo
	@echo TESTS=$(TESTS)
	@echo
	@echo MOD_TESTS=$(MOD_TESTS)
	@echo
	@echo ADVANCED=$(ADVANCED)
	@echo
	@echo UTILS=$(UTILS)
	@echo
	@echo SRC_FILES=$(SRC_FILES)
	@echo
	@echo HEADER_FILES=$(HEADER_FILES)



clean: cleanUtils cleanExamples cleanModules cleanTests cleanAdvanced 
	-rm -f lib/libAria.a lib/libAria.so $(OFILES) `find . -name core` `find . -name '*~'` obj/AriaPy.o obj/AriaJava.o

cleanUtils:
	-rm -f $(UTILS)

cleanExamples:
	-rm -f $(EXAMPLES) $(EXAMPLES_STATIC)

cleanTests:
	-rm -f $(TESTS) $(TESTS_STATIC)

cleanAdvanced:
	-rm -f $(ADVANCED)

cleanModules:
	-rm -f $(MOD_EXAMPLES)

cleanDoc:
	-rm  docs/*.html docs/*.png docs/doxygen.css

cleandoc: cleanDoc

cleanPython:
	-rm python/_AriaPy.so
	-rm python/AriaPy.py
	-rm python/AriaPy.pyc
	-rm python/AriaPy_wrap.cpp
	-rm python/AriaPy_wrap.h
	-rm obj/AriaPy_wrap.o

cleanpython: cleanPython

dep: clean 
	if [ -f `echo src/*.cpp | cut -d' ' -f1` ]; then \
	$(CXX) $(CXXFLAGS) $(CXXINC) -MM src/*.cpp | \
	awk '$$1 ~ /:/{printf "obj/%s\n", $$0} $$1 !~ /:/' > Makefile.dep; fi
	if [ -f `echo examples/*.cpp | cut -d' ' -f1` ]; then \
	$(CXX) $(CXXFLAGS) $(CXXINC) -MM examples/*.cpp | \
	awk '$$1 ~ /:/{printf "examples/%s$(binsuffix)\n", $$0} $$1 !~ /:/' | \
	sed 's/\.o//' >> Makefile.dep; fi
	if [ -f `echo utils/*.cpp | cut -d' ' -f1` ]; then \
	$(CXX) $(CXXFLAGS) $(CXXINC) -MM utils/*.cpp | \
	awk '$$1 ~ /:/{printf "utils/%s$(binsuffix)\n", $$0} $$1 !~ /:/' | \
	sed 's/\.o//' >> Makefile.dep; fi
	if [ -f `echo tests/*.cpp | cut -d' ' -f1` ]; then \
	$(CXX) $(CXXFLAGS) $(CXXINC) -MM tests/*.cpp | \
	awk '$$1 ~ /:/{printf "tests/%s$(binsuffix)\n", $$0} $$1 !~ /:/' | \
	sed 's/\.o//' >> Makefile.dep; fi
	if [ -f `echo advanced/*.cpp | cut -d' ' -f1` ]; then \
	$(CXX) $(CXXFLAGS) $(CXXINC) -MM advanced/*.cpp | \
	awk '$$1 ~ /:/{printf "advanced/%s$(binsuffix)\n", $$0} $$1 !~ /:/' | \
	sed 's/\.o//' >> Makefile.dep; fi

Makefile.dep:
	$(MAKE) dep

depAll: cleanDep
	make dep;
	for dir in `find . -maxdepth 1 -name "Ar*" -xtype d`; do cd $$dir; make dep; cd ..; done

cleanAll: clean 
	rm -f lib/lib*.so*
	for dir in `find . -maxdepth 1 -name "Ar*" -xtype d`; do cd $$dir; make clean; cd ..; done
	$(MAKE) -C ArVideo cleanAll
	$(MAKE) -C ArNetworking cleanAll

fullCleanAll: cleanAll cleanJava cleanPython 
	rm -f lib/lib*.so*
	rm -f obj/*.o*
	for dir in `find . -maxdepth 1 -name "Ar*" -xtype d`; do cd $$dir; make fullClean; cd ..; done



params: utils/makeParams$(binsuffix)
	-mkdir params

=== advanced/Makefile ===
# A simple $(MAKE)file to cause make to go look in the top directory. A simple
# convenience.

%.so: %.cpp 
	$(MAKE) -C .. advanced/$@

%: %.cpp 
	$(MAKE) -C .. advanced/$@

all:
	$(MAKE) -C .. advanced

clean:
	$(MAKE) -C .. cleanAdvanced

# netAudioAndSpeech needs extra libraries:

ifndef CXX
CXX=g++
endif

netAudioAndSpeech: netAudioAndSpeech.cpp ../lib/libArNetAudio.so ../lib/libArNetworking.so ../lib/libArSpeechSynth_Cepstral.so ../lib/libAria.so
	$(CXX) $(CFLAGS) -o $@ -I../include -I../ArNetworking/include -I../ArNetAudio/include -I../ArSpeechSynth_Cepstral/include $< -L../lib -lArNetAudio -lArNetworking -lArSpeechSynth_Cepstral -lAria -lswift -lspeex -lportaudio -lportmixer


# Make dependent libraries. Assumes that lib is in sibling directory with
# matching name.
../lib/lib%.so: ../%/src/*.cpp ../%/include/*.h
	$(MAKE) -C ../$* $@

../lib/libAria.so:
	$(MAKE) -C .. lib/libAria.so

=== examples/Makefile ===
# A simple $(MAKE)file to cause make to go look in the top directory. A simple
# convenience.

all: lib 
	$(MAKE) -C .. examples

lib:
	$(MAKE) -C .. lib/libAria.so

%.so: ../lib/libAria.so %.cpp 
	$(MAKE) -C .. examples/$@

%: ../lib/libAria.so %.cpp 
	$(MAKE) -C .. examples/$@

%Static: ../lib/libAria.a %.cpp 
	$(MAKE) -C .. examples/$@

clean: 
	$(MAKE) -C .. cleanExamples

../lib/libAria.so: FORCE
	$(MAKE) -C .. dirs lib/libAria.so

../lib/libAria.a: FORCE	
	$(MAKE) -C .. dirs lib/libAria.a

FORCE:

.PHONY: all FORCE clean lib

=== javaExamples/Makefile ===

ifdef JAVA_BIN
JAVAC=$(JAVA_BIN)/javac
JAVA=$(JAVA_BIN)/java
else
JAVAC=javac
JAVA=java
endif

#### Different options for Windows or Linux:
host:=$(shell uname | cut -d _ -f 1)
ifeq ($(host),MINGW32)  # host is MINGW32 on Windows:
CLASSPATH_SEP=;
RUNTIME_PATH_VAR=PATH
RUNTIME_LIB_DIR=../bin
LIB_EXT=dll
LIB_PREFIX=
else
CLASSPATH_SEP=:
RUNTIME_PATH_VAR=LD_LIBRARY_PATH
RUNTIME_LIB_DIR=../lib
LIB_EXT=so
LIB_PREFIX=lib
endif



all: $(patsubst %.java,%.class,$(wildcard *.java))

%.class: %.java ../java/Aria.jar $(RUNTIME_LIB_DIR)/$(LIB_PREFIX)Aria.$(LIB_EXT)
	@echo $^
	"$(JAVAC)" -classpath ../java/Aria.jar $<

run%: %.class
	$(RUNTIME_PATH_VAR)=$$$(RUNTIME_PATH_VAR):$(RUNTIME_LIB_DIR) "$(JAVA)" -cp ../java/Aria.jar:. $* $(ARGS)

gdb%: %.class
	$(RUNTIME_PATH_VAR)=$$$(RUNTIME_PATH_VAR):$(RUNTIME_LIB_DIR) gdb --args "$(JAVA)" -cp ../java/Aria.jar:. $* $(ARGS)

info:
	@echo host=$(host)
	@echo "JAVA_BIN=$(JAVA_BIN)"
	@echo "JAVAC=$(JAVAC)"
	@echo "JAVA=$(JAVA)"
	@echo "CLASSPATH_SEP=$(CLASSPATH_SEP)"
	@echo "RUNTIME_PATH_VAR=$(RUNTIME_PATH_VAR)"
	@echo "RUNTIME_LIB_DIR=$(RUNTIME_LIB_DIR)"
	@echo "LIB_EXT=$(LIB_EXT)"

=== src/Makefile ===
# A simple $(MAKE)file to cause make to go look in the top directory. A simple
# convience.

all:
	$(MAKE) -C ..

dep:
	$(MAKE) -C .. dep

clean:
	$(MAKE) -C .. clean

examples:
	$(MAKE) -C .. examples

=== tests/Makefile ===
# A simple $(MAKE)file to cause $(MAKE) to go look in the top directory. A simple
# convenience.

all: ../lib/libAria.so
	$(MAKE) -C .. tests

.PHONY: all clean FORCE

../lib/libAria.so: FORCE
	$(MAKE) -C .. dirs lib/libAria.so

../lib/libAria.a: FORCE
	$(MAKE) -C .. dirs lib/libAria.a

%.so: ../lib/libAria.so %.cpp 
	$(MAKE) -C .. tests/$@

%: ../lib/libAria.so %.cpp 
	$(MAKE) -C .. tests/$@

%Static: ../lib/libAria.a %.cpp
	$(MAKE) -C .. tests/$@

clean: 
	$(MAKE) -C .. cleanTests

FORCE:

=== utils/Makefile ===
# A simple makefile to cause make to go look in the top directory. A simple
# convience.

all:
	$(MAKE) -C .. utils

clean: 
	$(MAKE) -C .. cleanUtils

%: %.cpp
	$(MAKE) -C .. utils/$@

=== ArNetworking/examples/Makefile ===

all:
	$(MAKE) -C .. examples

%: %.cpp
	$(MAKE) -C .. examples/$@

.PHONY: all

=== ArNetworking/javaExamples/Makefile ===

ifdef JAVA_BIN
JAVAC=$(JAVA_BIN)/javac
JAVA=$(JAVA_BIN)/java
else
JAVAC=javac
JAVA=java
endif

#### Different options for Windows or Linux:
host:=$(shell uname | cut -d _ -f 1)
ifeq ($(host),MINGW32)  # host is MINGW32 on Windows:
CLASSPATH_SEP=;
RUNTIME_PATH_VAR=PATH
RUNTIME_LIB_DIR=../../bin
LIB_EXT=dll
LIB_PREFIX=
else
CLASSPATH_SEP=:
RUNTIME_PATH_VAR=LD_LIBRARY_PATH
RUNTIME_LIB_DIR=../../lib
LIB_EXT=so
LIB_PREFIX=lib
endif



all: $(patsubst %.java,%.class,$(wildcard *.java))

%.class: %.java ../../java/Aria.jar ../../java/ArNetworking.jar $(RUNTIME_LIB_DIR)/$(LIB_PREFIX)Aria.$(LIB_EXT) $(RUNTIME_LIB_DIR)/$(LIB_PREFIX)ArNetworking.$(LIB_EXT)
	@echo $^
	"$(JAVAC)" -classpath "../../java/Aria.jar$(CLASSPATH_SEP)../../java/ArNetworking.jar" $<

run%: %.class
	$(RUNTIME_PATH_VAR)=$$$(RUNTIME_PATH_VAR):$(RUNTIME_LIB_DIR) "$(JAVA)" -cp ../../java/Aria.jar:../../java/ArNetworking.jar:. $* $(ARGS)

gdb%: %.class
	$(RUNTIME_PATH_VAR)=$$$(RUNTIME_PATH_VAR):$(RUNTIME_LIB_DIR) gdb --args "$(JAVA)" -cp ../../java/Aria.jar:../../java/ArNetworking.jar:. $* $(ARGS)

info:
	@echo host=$(host)
	@echo "JAVA_BIN=$(JAVA_BIN)"
	@echo "JAVAC=$(JAVAC)"
	@echo "JAVA=$(JAVA)"
	@echo "CLASSPATH_SEP=$(CLASSPATH_SEP)"
	@echo "RUNTIME_PATH_VAR=$(RUNTIME_PATH_VAR)"
	@echo "RUNTIME_LIB_DIR=$(RUNTIME_LIB_DIR)"
	@echo "LIB_EXT=$(LIB_EXT)"

=== ArNetworking/tests/Makefile ===

.PHONY: all

all:
	$(MAKE) -C .. tests

%: %.cpp
	$(MAKE) -C .. tests/$@

=== debian/changelog ===
libaria (2.8.0+repack-1ubuntu2) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 04 Aug 2015 04:40:30 +0000

libaria (2.8.0+repack-1ubuntu1) trusty; urgency=low

  * Resynchronise with Debian (LP: #1243245).  Remaining changes:
    - Link libAria.so with -lpthread -ldl -lrt, rather than passing those
      options only when linking the objects that are linked with libAria.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 22 Oct 2013 17:59:44 +0100

libaria (2.8.0+repack-1) unstable; urgency=low

  * New upstream version (2.8.0).

 -- Srećko Jurić-Kavelj <srecko.juric-kavelj@fer.hr>  Fri, 20 Sep 2013 19:44:53 +0200

libaria (2.7.5.2+repack-3ubuntu1) saucy; urgency=low

  * Link libAria.so with -lpthread -ldl -lrt, rather than passing those
    options only when linking the objects that are linked with libAria.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 15 Oct 2013 16:27:20 +0100

libaria (2.7.5.2+repack-3) unstable; urgency=low

  * Removed statically linked library.
  * Corrected Multi-Arch config for the doc package.
    Also, generating documentation in a build-indep target.
  * Building python-ariapy package (SWIG generated bindings)
  * Building libaria-demo package
  * Added test target for dh_autotest.

 -- Srećko Jurić-Kavelj <srecko.juric-kavelj@fer.hr>  Wed, 19 Jun 2013 11:17:59 +0200

=== debian/control ===
Source: libaria
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Srećko Jurić-Kavelj <srecko.juric-kavelj@fer.hr>
Build-Depends: debhelper (>= 9), swig, python-dev
Build-Depends-Indep: doxygen
Standards-Version: 3.9.4
Section: libs
Homepage: http://robots.mobilerobots.com/wiki/ARIA
Vcs-Git: git://github.com/jksrecko/libaria.git
Vcs-browser: https://github.com/jksrecko/libaria

Package: libaria-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libaria2v5 (= ${binary:Version}), ${misc:Depends}
Description: C++ library for MobileRobots/ActivMedia robots (devel)
 ARIA is an object oriented toolkit for controlling MobileRobots/ActivMedia
 mobile robots and their accessories, and for creating robot control
 applications. It also provides many cross-platform and high-level tools for
 multimedia, networking, and other useful tasks.
 .
 This package contains static libraries and header files.

Package: libaria-demo
Section: libdevel
Architecture: any
Depends: libaria2v5 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: C++ library for MobileRobots/ActivMedia robots (demo example)
 ARIA is an object oriented toolkit for controlling MobileRobots/ActivMedia
 mobile robots and their accessories, and for creating robot control
 applications. It also provides many cross-platform and high-level tools for
 multimedia, networking, and other useful tasks.
 .
 This package contains the demo example of the library functions. The example
 is renamed to aria-demo and can be used to experiment and test the robot's
 hardware.

Package: libaria2v5
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libaria2
Replaces: libaria2
Description: C++ library for MobileRobots/ActivMedia robots
 ARIA is an object oriented toolkit for controlling MobileRobots/ActivMedia
 mobile robots and their accessories, and for creating robot control
 applications. It also provides many cross-platform and high-level tools for
 multimedia, networking, and other useful tasks.
 .
 This package contains shared libraries.

Package: libaria-dev-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libaria-dev (= ${binary:Version})
Description: C++ library for MobileRobots/ActivMedia robots (devel docs)
 ARIA is an object oriented toolkit for controlling MobileRobots/ActivMedia
 mobile robots and their accessories, and for creating robot control
 applications. It also provides many cross-platform and high-level tools for
 multimedia, networking, and other useful tasks.
 .
 This package contains doxygen generated documentation.

Package: python-ariapy
Section: python
Architecture: any
Depends: libaria2v5 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Description: C++ library for MobileRobots/ActivMedia robots (Python bindings)
 ARIA is an object oriented toolkit for controlling MobileRobots/ActivMedia
 mobile robots and their accessories, and for creating robot control
 applications. It also provides many cross-platform and high-level tools for
 multimedia, networking, and other useful tasks.
 .
 This package contains SWIG generated Python bindings.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export INSTALL_DIR=/usr
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --with python2 --parallel

override_dh_auto_build-indep:
	$(MAKE) -C . docs

override_dh_installchangelogs:
	dh_installchangelogs Changes.txt upstream

override_dh_installdocs:
	dh_installdocs -Xfigures/ -Xoptions/ -X.dox

get-orig-source:
	wget http://robots.mobilerobots.com/ARIA/download/current/ARIA-2.8.0+gcc4.6.tgz
	tar xzf ARIA-2.8.0+gcc4.6.tgz
	mv Aria-2.8.0 libaria-2.8.0.orig
	cd libaria-2.8.0.orig && patch -p1 < ../patches/fix-upstream-makefile.patch
	make -C libaria-2.8.0.orig fullCleanAll cleanDoc cleanParams cleanSwigJava
	cd libaria-2.8.0.orig && patch -p1 -R < ../patches/fix-upstream-makefile.patch
	tar cjf libaria_2.8.0+repack.orig.tar.bz2 libaria-2.8.0.orig/
	rm -rf libaria-2.8.0.orig/ ARIA-2.8.0+gcc4.6.tgz

=== debian/watch ===
version=3
opts=dversionmangle=s/\+repack$// \
http://robots.mobilerobots.com/wiki/ARIA \
http://robots.mobilerobots.com/ARIA/download/current/ARIA-([0-9\.]+)\+gcc.+\.tgz
